//+------------------------------------------------------------------+
//|                                                 PolyFitMA_v1.mq4 |
//|                                Copyright  2007, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//|                                       adaptive changes by mladen |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Orange
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  1
#property indicator_style2  STYLE_DOT

//
//
//
//
//

extern int    Price         =    0;   //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close)
extern int    Length        =   50;   //Number of bars for an evaluation
extern int    Degree        =    4;   //Degree of a Polynomial(no more 12)
extern int    SwingCount    =   30;
extern double Speed         =  0.2;
extern int    MinimalLength =   10;
extern int    PriceMaLength =    1;   //Period of Preliminary Smoothing
extern int    PriceMaMode   =    0;   //Mode of MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA
extern int    ProjLength    =    0;   //Length of Projection
extern int    FitMode       =    0;   //Fitting Mode: 0-Fitting,1-Moving
extern bool   Adaptive      = true;

//
//
//
//
//

double PolyFitMA[];
double Project[];
double prices[];
double PriceArray[];

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0, PolyFitMA); SetIndexLabel(0,"PolyFitMA");
      SetIndexBuffer(1, Project);   SetIndexLabel(1,"Projection"); SetIndexShift(1,ProjLength);
      SetIndexBuffer(2, prices);
   
         FitMode = MathMax(MathMin(FitMode,1),0);
   
   IndicatorShortName("PolyFitMA("+Price+","+Length+","+Degree+")");
   return(0);
}

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

double swings[][2];

//
//
//
//
//

int start()
{
   int i,k,n,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

      

   //
   //
   //
   //
   //
   
   if (ArrayRange(swings,0)!=Bars) ArrayResize(swings,Bars);

      //
      //
      //
      //
      //
      
      for(i=limit, r=Bars-i-1; i>=0; i--, r++)
      {
         prices[i] = iMA(NULL,0,PriceMaLength,0,PriceMaMode,Price,i);
         
         //
         //
         //
         //
         //
         
         if (Adaptive)
         {
            swings[r][0] = 0;
               if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swings[r][0] = -1;
               if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swings[r][0] =  1;
               for (k=r, n=0; (k>=0) && (n<SwingCount); k--) if (swings[k][0] != 0) n++;
                                                                 swings[r][1] = MathMax(MathRound((r-k)/SwingCount/Speed),MinimalLength);
         }
         else swings[r][1]=Length;
      }   
   
   //
   //
   //
   //
   //
      
      if (FitMode==0) limit = swings[Bars-1][1]-1;

      //
      //
      //
      //
      //
         
      for (i=limit, r=Bars-i-1; i>=0; i--,r++ )
      {
         if (FitMode==1)
               Length = swings[r     ][1];
         else  Length = swings[Bars-1][1];
        
         //
         //
         //
         //
         //

         ArrayResize(PriceArray,Length); ArrayCopy(PriceArray,prices,0,i*FitMode,Length);

            //
            //
            //
            //
            //
                     
            PolyFitMA[i] = PolyFit(PriceArray,Degree,Length,i*(FitMode-1));
            if(ProjLength > 0 && i == 0)
                  for (int j=0; j<=ProjLength; j++) Project[j] = PolyFit(PriceArray,Degree,Length,ProjLength-j);
      }
   
   //
   //
   //
   //
   //
   
   if (FitMode==0) SetIndexDrawBegin(0,Bars-Length+1);
   if (FitMode==1) SetIndexDrawBegin(0,0);
   return(0);
}


//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

double PolyFit(double price[],int deg,int len,int bar)
{
double   result=0,Sum=0;
double   AX[13,13],BX[13],CX[13],ZX[13],Pow[26];
int      Row[13];  
// FILL MATRIX FIRST

   if (len<=1)	Sum=price[0];
   else
   {	
   
   for (int j=1;j<=deg+1;j++) BX[j]=0;
		
		for (int k=1;k<=len;k++) 
  	   {
  	   double YK=price[len-k];
  	   double XK=k;
  	   double Prod=1;
  	      for (j=1;j<=deg+1;j++)
    	   {
    	   BX[j]+= YK*Prod;
    	   Prod*=XK;
  		   }
      }
      
   for (j=0;j<=2*deg;j++) Pow[j]=0;
	
	Pow[0]=len;
	
      for (k=1;k<=len;k++)
	   {
  	   XK=k;
  	   Prod=k;
  	      for (j=1;j<=2*deg;j++)
  	      {
    	   Pow[j]+= Prod;    	   
    	   Prod*= XK;
  		   }
      }	
	
	   for (j=1;j<=deg+1;j++)
	   {	
         for (int l=1;l<=deg+1;l++) 
  	      AX[j,l]=Pow[j+l-2];
      }	
//NOW SOLVE FOR COEFFICIENTS

	for (j=1;j<=deg+1;j++) Row[j]=j;
  	
      for (int i=1;i<=deg;i++)
  	   {
  	      for (k=i+1;k<=deg+1;k++)
         {
            if(MathAbs(AX[Row[k],i]) > MathAbs(AX[Row[i],i]))
      	   {	
      	   int Temp=Row[i];
      	   Row[i]=Row[k];
      	   Row[k]=Temp;
            }
         }

         for (k=i+1;k<=deg+1;k++)
    	   {
    	   if(AX[Row[i],i]!=0) AX[Row[k],i]=AX[Row[k],i]/AX[Row[i],i];
    		   for (l=i+1;l<=deg+1;l++)
      	   AX[Row[k],l]=AX[Row[k],l]-AX[Row[k],i]*AX[Row[i],l];
    		}
		}

   ZX[1]=BX[Row[1]];
      
      for (k=2;k<=deg+1;k++)
  	   {
  	   Sum=0;
      for (l=1;l<=k-1;l++) Sum+=AX[Row[k],l]*ZX[l];
  	   
  	   ZX[k]=BX[Row[k]]-Sum;
	   }
     
	if(AX[Row[deg+1],deg+1] != 0) CX[deg+1]=ZX[deg+1]/AX[Row[deg+1],deg+1];
      	
      for (k=deg;k>=1;k--)
  	   {
  	   Sum=0;
  	   //l=k+1;  		
  	   for (l=k+1;l<=deg+1;l++) Sum += AX[Row[k],l]*CX[l]; //AX[Row[KX],Col]*CX[Col];
  	   CX[k]=(ZX[k]-Sum)/AX[Row[k],k];
	   }
    
//NOW COMPUTE NEXT POINT IN SERIES AND RETURN}

	Sum=CX[deg+1];
	for (k=deg;k>=1;k--) Sum=CX[k]+Sum*(len+bar);
   
   }
   return (Sum);
}